<template>
    <el-drawer
        :visible="!isCollapsed"
        :before-close="menuCollapseTrigger"
        :show-close="false"
        size="16em"
        direction="ltr"
        :appendToBody="true"
        :style="style">
        <div class="el-drawer-as-sidebar-main">
            <template v-for="(sidebarNode) in sidebarNodeList">
                <div v-bind:key="`${sidebarNode.name}_span`"
                    @click="navigateTo(sidebarNode)"
                    class="el-drawer-as-sidebar-element">
                    <i :class="sidebarNode.icon"></i>
                    <span slot="title">{{$t(sidebarNode.name)}}</span>
                </div>
                <el-divider v-bind:key="`${sidebarNode.name}_divider`"></el-divider>
            </template>
        </div>
    </el-drawer>
</template>
<style>
.el-drawer-as-sidebar-main {
    display: flex;
    flex-direction: column;
    padding-left: 1.2rem;
    padding-right: 1.2rem;
}
.el-drawer-as-sidebar-element {
    width: 100%;
    padding:0.2rem;
    border-radius: 0.4rem;
    transition: all 0.5s;
}
.el-drawer-as-sidebar-element:hover {
    transition: all 0.5s;
    background-color: #eee;
    color: rgba(255, 0, 0, 1);
    box-shadow: inset 0 0 0.5rem rgba(255, 0, 0, 1);
    -webkit-box-shadow: inset 0 0 0.5rem rgba(255, 0, 0, 1);
    -moz-box-shadow: inset 0 0 0.5rem rgba(255, 0, 0, 1);
    -o-box-shadow: inset 0 0 0.5rem rgba(255, 0, 0, 1);
}
.el-drawer.ltr{
    background-color: #ff0000;
}
</style>
<script>
"use strict";

import Logo from "./../../logo.svg";
import SidebarNodeList from "./sidebar";

export default {
    name: "Sidebar2",
    data() {
        return {
            sidebarNodeList: SidebarNodeList,
            logo: Logo
        };
    },
    created() {
        // Close the sidebar on release of "esc" and "ctrl"
        window.addEventListener("keyup", (event) => {
            if (document.activeElement.tagName.toUpperCase() !== "INPUT" &&
                document.activeElement.tagName.toUpperCase() !== "TEXTAREA" &&
                (event.keyCode === 27 || event.key.toUpperCase() === "Z")) {
                this.$store.commit("sidebarCollapse");
            }
        });
        // Open the sidebar on press of "ctrl"
        window.addEventListener("keydown", (event) => {
            if (document.activeElement.tagName.toUpperCase() !== "INPUT" &&
                document.activeElement.tagName.toUpperCase() !== "TEXTAREA" &&
                event.key.toUpperCase() === "Z") {
                this.$store.commit("sidebarExpand");
                document.activeElement.blur();
            }
        });
    },
    computed: {
        rotation() {
            return {
                transform: `rotate(${this.isCollapse? 90 : 0}deg)`
            };
        },
        isCollapsed() {
            return this.$store.state.ui.sidebar.isCollapsed;
        },
        primaryColor: () => process.env.PRIMARY_COLOR,
        primaryText: () => process.env.PRIMARY_TEXT,
        activeColor: () => process.env.ACTIVE_COLOR,
        activeText: () => process.env.ACTIVE_TEXT,
        style() {
            return `color:${this.primaryText};`;
        }
    },
    methods: {
        menuCollapseTrigger() {
            this.$store.commit("sidebarCollapse");
        },
        navigateTo(sidebarNode) {
            try {
                this.$router.push(sidebarNode.route);
            } catch (ignore) {}
        }
    }
};
</script>
